using namespace RooFit ;

void ex3()
{
  // Make an empty workspace that exports its contents to CINT
  RooWorkspace *w = new RooWorkspace("w",kTRUE) ;  

  // This constructs the same model as ex1.
  w->factory("S[0,0,100]") ;
  w->factory("B[5]") ;       
  w->factory("N[0,100]") ;
  w->factory("expr::Nexp('S+B',S,B)") ;  
  w->factory("Poisson::model(N,Nexp)") ;

  // *** STEP1 **
  return ;

  // *** Building models with a more compact syntax ***
  
  // The code below constructs the same model, but taking advantages
  // of the factories 'composition' technique that allows to
  // create objects 'in place' where they are first needed
  //
  // In this iteration we only create the variable objects in the place where they
  // are needed first.   
  w->factory("expr::Nexp('S+B',S[0,0,100],B[5])") ;  
  w->factory("Poisson::model(N[0,100],Nexp)") ;


  // Have a look at all the objects created in the workspace
  w->Print("t") ;


}
