void makeinput_ex11()
{
  RooWorkspace w("w") ;
  w.factory("Gaussian::sig(x[20,120],91,5)") ;
  w.factory("Uniform::bkg(x)") ;
  w.factory("SUM::model(0.1*sig,0.9*bkg)") ;
  w.var("x")->setBins(20) ;
  
  RooDataHist* dh_sig = w.pdf("sig")->generateBinned(*w.var("x"),1000) ;
  RooDataHist* dh_bkg = w.pdf("bkg")->generateBinned(*w.var("x"),10000) ;

  RooDataHist* data       = w.pdf("model")->generateBinned(*w.var("x"),11000) ;
  RooDataHist* data_small = w.pdf("model")->generateBinned(*w.var("x"),1100) ;
  RooDataHist* data_large = w.pdf("model")->generateBinned(*w.var("x"),111000) ;

  TH1* h_sig = dh_sig->createHistogram("x") ; h_sig->SetName("h_sig") ;
  TH1* h_bkg = dh_bkg->createHistogram("x") ; h_bkg->SetName("h_bkg") ;
  TH1* h_data = data->createHistogram("x") ; h_data->SetName("h_data") ;
  TH1* h_data_small = data_small->createHistogram("x") ; h_data_small->SetName("h_data_small") ;
  TH1* h_data_large = data_large->createHistogram("x") ; h_data_large->SetName("h_data_large") ;

  TFile f("ex11.root","RECREATE") ;
  h_sig->Write() ;
  h_bkg->Write() ;
  h_data->Write() ;
  h_data_small->Write() ;
  h_data_large->Write() ;
}
