void makeinput_ex12()
{
  RooWorkspace w("w") ;
  w.factory("Gaussian::sig(x[20,120],mean[91],width[5])") ;
  w.factory("Uniform::bkg(x)") ;
  w.factory("SUM::model(0.1*sig,0.9*bkg)") ;
  
  w.var("mean")->setVal(93) ; RooDataHist* dh_sig_up = w.pdf("sig")->generateBinned(*w.var("x"),1000) ;
  w.var("mean")->setVal(91) ; RooDataHist* dh_sig    = w.pdf("sig")->generateBinned(*w.var("x"),1000) ;
  w.var("mean")->setVal(89) ; RooDataHist* dh_sig_dn = w.pdf("sig")->generateBinned(*w.var("x"),1000) ;
  RooDataHist* dh_bkg    = w.pdf("bkg")->generateBinned(*w.var("x"),10000) ;

  w.var("mean")->setVal(91) ;
  RooDataHist* data       = w.pdf("model")->generateBinned(*w.var("x"),11000) ;

  TH1* h_sig_up = dh_sig_up->createHistogram("x") ; h_sig_up->SetName("h_sig_up") ;
  TH1* h_sig    = dh_sig->createHistogram("x") ; h_sig->SetName("h_sig") ;
  TH1* h_sig_dn = dh_sig_dn->createHistogram("x") ; h_sig_dn->SetName("h_sig_dn") ;
  TH1* h_bkg    = dh_bkg->createHistogram("x") ; h_bkg->SetName("h_bkg") ;
  TH1* h_data   = data->createHistogram("x") ; h_data->SetName("h_data") ;

  TFile f("ex12.root","RECREATE") ;
  h_sig_up->Write() ;
  h_sig->Write() ;
  h_sig_dn->Write() ;
  h_bkg->Write() ;
  h_data->Write() ;
}
