using namespace RooFit ;

void ex5sol()
{
  // Make an empty workspace that exports its contents to CINT
  RooWorkspace *w = new RooWorkspace("w") ;  

  // Construct the model ex4
  w->factory("Poisson::model(N[100],expr::Nexp('mu*S+B',mu[1,0,5],S[20],B[0,100]))") ;

  w->factory("Gaussian::subsidiary(Bnom[20],B,sigmaB[5])") ;
  w->factory("PROD::model2(model,subsidiary)") ;

  w->factory("Poisson::control_model(Nctl[20],B)") ;
  w->factory("PROD::model3(model,control_model)") ;
  
  w->factory("Poisson::control_model2(Nctl[20],expr::Nexp2('tau*B',B,tau[2]))") ;
  w->factory("PROD::model4(model,control_model2)") ;
 
  RooDataSet data("data","data",*w->var("N")) ;
  w->var("N")->setVal(45) ;
  data.add(*w->var("N")) ;
  
  w->pdf("model2")->fitTo(data) ;
  w->pdf("model3")->fitTo(data) ;
  w->pdf("model4")->fitTo(data) ;
      
}
