using namespace RooFit ;

void ex6sol()
{
  // Make an empty workspace that exports its contents to CINT
  RooWorkspace *w = new RooWorkspace("w") ;  

  // Construct the model ex4
  w->factory("Poisson::model(N[100],expr::Nexp('mu*S+B1+B2',mu[1,0,5],S[20,0,100],B1[10,0,100],B2[10,0,100]))") ;
  w->factory("Gaussian::subsidiary(B1nom[10],B1,sigmaB[5])") ;
  w->factory("Poisson::subsidiary2(B2nom[10],B2)") ;
  w->factory("Gaussian::subsidiary3(Snom[20],S,sigmaS[1])") ;
  w->factory("PROD::model2(model,subsidiary,subsidiary2,subsidiary3)") ;
  
  RooDataSet data("data","data",*w->var("N")) ;
  w->var("N")->setVal(45) ;
  data.add(*w->var("N")) ;
  
  w->pdf("model2")->fitTo(data) ;
   
}
